2009-03-13  Jan Niklas Hasse  <jhasse@gmail.com>

	* apgcc: Use warn instead of print to display warnings. Thanks to Scott
	Pakin for the patch.

--------------------  2.0.8 was released  --------------------

2009-03-11  Jan Niklas Hasse  <jhasse@gmail.com>

	* Apbuild/GCC.pm: Applied patch by Mike Lundy which fixes compiling of
	libpng where apgcc detected a symbol list as precompiled header rather than
	a depcheck. Fixes #118.
	* apsymbols.h: New symbol list created on a GLIBC_2.9 machine by Mike
	Lundy. Thanks! Fixes #117.

2009-03-11  Jan Niklas Hasse  <jhasse@gmail.com>

	* apgcc: Applied patch by Scott Pakin which shows a warning message when
	a library in APBUILD_STATIC isn't found.
	* Apbuild/GCC.pm: getSearchPaths: Correctly add the content of the list not
	a reference. Also a patch by Scott Pakin, thanks!

2009-03-10  Jan Niklas Hasse  <jhasse@gmail.com>

	* apgcc: Applied patch by Scott Pakin which fixes statically compiling
	of libuuid.

--------------------  2.0.7 was released  --------------------

2008-11-10  Jan Niklas Hasse  <jhasse@gmail.com>

	* Apbuild/GCC.pm: Check if FORTIFY_SOURCE is available. I'm not sure if
	this really was introduced in gcc 4.1, but it should fix the the linker
	errors in Ubuntu 8.10 and other new distros using this feature.
	* apgcc: Add -U_FORTIFY_SOURCE to deactivate FORTIFY_SOURCE=2.

2008-09-11  Jan Niklas Hasse  <jhasse@gmail.com>

	* buildlist: Bump minimum GLibc version to 2.3 (from 2.2)
	* apsymbols.h: update list to work with the new 2.3 glibc min version
	  (Patch from Taj, me and Isak, should fix #20)
	* apgcc: Check if APBUILD_STATIC_X is definied to prevent warnings.

2008-08-03  Jan Niklas Hasse  <jhasse@gmail.com>

	* relaytool: Check if /dev/tty exists. Fixes #63

2008-08-03  Jan Niklas Hasse  <jhasse@gmail.com>

	* apgcc: Don't statically link X11 libs by default. Fixes #61

--------------------  2.0.6 was released  --------------------

Sun Dec 30 19:17:03 UTC 2007  Taj Morton  <tajmorton@gmail.com>
	* relaytool: Apply patch from res in ticket #52. Now, if a lib cannot be relaytooled
	  for some reason, a stub that ensures libwhatever_is_present is defined will be
	  generated.

Sun Sep 30 00:29:13 UTC 2007  Taj Morton  <tajmorton@gmail.com>
	* relaytool: When multi-linking, use the first SONAME passed to --multilink
	  as the name to use for the _is_present variable and _symbol_is_present function.
	  Fixes #37.

Sat Sep 22 02:39:11 UTC 2007  Taj Morton  <tajmorton@gmail.com>
	* relaytool: Add --out-dir feature by user 'res' in ticket #50.

2007-09-22  Isak Savo  <isak.savo@gmail.com>

	* relaytool (arch_ptr_size): Use 'uname -m' instead of 'arch' to get
	machine name. Patch from user 'res' in ticket #51 (ticket fixed by
	this commit)

Tue Aug 14 17:04:32 UTC 2007  Taj Morton  <tajmorton@gmail.com>
	* apgcc: Apply patch from Unfleshed One for precompiled header support. Fixes #32.
	* Apbuild/GCC.pm: Apply patch from Unfleshed One from precompiled header and
	  SCons/Qt4 integration. Fixes #32.

Tue Aug 14 16:51:30 UTC 2007  Taj Morton  <tajmorton@gmail.com>
	* relaytool: When running on unsupported arch, give correct
	  defines for lib_is_present and symbol_is_present.

Mon Jul  9 23:22:21 UTC 2007  Curtis L. Knight  <knighcl@gmail.com>
	* apgcc: Update for 2.0.6 release.
	* Makefile: Update for 2.0.6 release.

--------------------  2.0.5 was released  --------------------

Mon Jun  4 02:03:06 UTC 2007  Taj Morton  <tajmorton@gmail.com>
	* apgcc: Append statically linked file's deps before adjusting
	  link line so that you can statically link the deps of the
	  libs you're statically linking (if that made any sense).

Sat May 26 15:28:14 UTC 2007  Taj Morton  <tajmorton@gmail.com>
	* make-icons: Put icons into a directory called icons relative to
	  where make-icons was run from. Ask user for type so that icons get
	  put in correct subdirectory.

Fri May 25 03:02:28 UTC 2007  Curtis L. Knight  <knighcl@gmail.com>
	* apgcc: Update for 2.0.5 release.
	* Makefile: Update for 2.0.5 release.

Wed May 23 00:45:48 UTC 2007  Taj Morton  <tajmorton@gmail.com>
	* apgcc: When statically linking, find the lib's DT_NEEDED entries
	  and link against them so we don't get linking errors.

Thu May 17 20:38:11 UTC 2007  Taj Morton  <tajmorton@gmail.com>
	* relaytool: Use /bin/bash instead of /bin/sh so we can work on
	  Ubuntu (where sh -> dash). Thanks ACSpike. Add multilink support
	  to relaytool (TODO: document it better).

--------------------  2.0.4 was released  --------------------

Sun Apr  8 11:22:23 UTC 2007  Curtis L. Knight  <knighcl@gmail.com>
	* apgcc: Update for 2.0.4 release.
	* Makefile: Update for 2.0.4 release.

Sat Mar 31 21:09:45 UTC 2007  Taj Morton  <tajmorton@gmail.com>
	* Apbuild/GCC.pm: Check if gcc supports -fstack-protector,
	  so it can be disabled.
	* apgcc: If gcc supports -fstack-protector, disable it (it adds a
	  silent dependency on GLIBC 2.4).
	* apsymbols.h: Rebuilt with GLIBC 2.4. Thanks to Chris Guirl for
	  rebuilding.

Thu Mar 29 05:08:40 UTC 2007  Taj Morton  <tajmorton@gmail.com>
	* apgcc: Respect the $APBUILD_NO_STATIC_X variable (as
	  documented on website). This doesn't mean it's a good idea
	  to use this features.

--------------------  2.0.3 was released  --------------------

Sun Dec 17 01:05:08 UTC 2006  Curtis L. Knight  <knighcl@fastmail.fm>
	* apgcc: Update for 2.0.3 release.
	* Makefile: Update for 2.0.3 release.

Sat Nov 25 23:20:07 UTC 2006  Taj Morton  <tajmorton@gmail.com>
	* Apbuild/GCC.pm: Detect if ld supports --hash-style so that we
	  can force both .gnu.hash and .hash to be generated on FC6.
	* apgcc: If linker supports --hash-style, generate both .gnu.hash
	  and .hash sections so that binary works with linkers with support for
	  either type. By default, FC6 only generates .gnu.hash which makes its
	  binaries only work on systems with .gnu.hash. See:
	  http://fcp.surfsite.org/modules/newbb/viewtopic.php?topic_id=29929&forum=10&post_id=128939

--------------------  2.0.2 was released  --------------------

Thu Nov  2 22:53:33 UTC 2006  Taj Morton  <tajmorton@gmail.com>
	* apgcc: Allow people to replace -I flags passed to apgcc with ones from
	  $APBUILD_INCLUDE. For example /opt/kde/include=/home/taj/kde-includes/3.3
	  replaces -I/opt/kde/include with -I/home/taj/kde-includes/3.3. This is only
	  useful for apps where include path order is important (amarok 1.4.3, see
	  comments for details).

--------------------  2.0.1 was released  --------------------

Fri Oct 13 14:54:54 UTC 2006  Taj Morton  <tajmorton@gmail.com>
	* apgcc: Revert commit that "Just use[d] the multiple-file code for link and compile
	  in 1 command." This broke compiling main/libexec. Post 1.2 this code will get
	  better, I promise. :)

Thu Oct 12 04:36:56 UTC 2006  Taj Morton  <tajmorton@gmail.com>
	* apgcc: [translateLibNames()]: Always find libstdc++ if compiling C++, force
	  use of the compilers libstdc++, instead of what libtool provides (which
	  is probably wrong when using your non-system g++).

Mon Oct  9 00:57:48 UTC 2006  Taj Morton  <tajmorton@gmail.com>
	* apgcc: Remove special case with compiling and linking in 1 command with
	  1 file. This code never called linkObjects() and so X libs were never
	  statically linked in. Just use the multiple-file code for link and compile in 1
	  command.
	  [forceStatic()]: Link Xfixes if Xcursor is linked because sometimes Xcursor
	  depends on Xfixes (on Slack 11, xorg 6.9.0, at least).

Sun Sep 24 22:38:50 UTC 2006  Taj Morton  <tajmorton@gmail.com>
	* apgcc: [rearrangeForAsNeeded()]: Put -lXRender at the end of the
	  link command. See 
	  http://lists.sunsite.dk/cgi-bin/ezmlm-cgi?21:mss:5187:200609:lkfnloheeaingojmnemi
	  for details.

2006-09-13  Isak Savo  <isak.savo@gmail.com>

	* Makefile (PREFIX): Replaced bash specific '[[' testing with 'test' to work better with Ubuntu Edgy's 'dash' shell

Thu Sep  7 19:10:53 UTC 2006  Taj Morton  <tajmorton@gmail.com>
	* apgcc: When compiling and linking in 1 command make sure
	  bogus deps are stripped. Note: I did not update the
	  double-compilation part of the code to have the fix because
	  it's dead code.

Tue May 30 01:04:05 2006  Mike Hearn  <mike@plan99.net>
	
	* relaytool: Add x64 support based on patch by Psyche.
	  Fix a couple of minor bugs and make the code flow better.

Thu Apr 13 23:56:32 2006  Mike Hearn  <mike@plan99.net>

	* apgcc (translateLibNames): Only drop libstdc++.so from the
	  arguments list when double compiling. This fixes the case
	  when libtool passes -nostdlib and then gives us a libstdc++
	  directly. However it's kind of a hack and will need to be
	  changed to work properly with double compiling.

2006-03-04  Hongli Lai <hongli@plan99.net>

	* apgcc: Apply patch by Francesco Montorsi.
	  This adds a new option APBUILD_RESOLVE_LIBPATH, which is a
	  space-seperated list of regular expressions which specify the
	  libraries whose path must be resolved into absolute paths.
	  This works around certain linking problems with static libraries,
	  when the order of the linking arguments is changed.

2006-02-04  Peter Lund <firefly@diku.dk>

	* APBuild/GCC.pm: Fix double linking of .moc.o files

2006-02-01 Peter Lund <firefly@diku.dk>

	* apgcc: Add support gcc-2.9x.
		Minor comment/--help fixes. See
		http://comments.gmane.org/gmane.comp.autopackage.devel/4408
		for more details
	* APBuild/GCC.pm, APBuild/Utils.pm: Make apgcc work with ccache.

2006-01-23 Peter Lund <firefly@diku.dk>

	* Makefile: Use eager notation (`:=') instead of `=' for var assignment. Add $(PROGS)-variable to hold all binary names.
	

2005-12-02  Hongli Lai  <hongli@plan99.net>
	* apgcc (rearrangeForAsNeeded):
	  Special case -lbfd and -liberty as they can cause link failures in
	  some cases.

2005-11-30  Hongli Lai  <hongli@plan99.net>
	* apgcc:
	  Do not link to incorrect libstdc++ version: remove
	  /usr/lib/libstdc++.so.x from the arguments.

2005-11-08  Hongli Lai  <hongli@plan99.net>
	* apgcc, Apbuild/GCC.pm, Apbuild/Utils.pm:
	  - Code cleanups.
	  - Fix C++ double compiling bugs: correctly set output filename
	    when -o is not given, surpress gcc output when double compiling.

2005-11-07  Hongli Lai  <hongli@plan99.net>
	* apgcc (linkObjects): remove duplicate system() call which
	  does nothing good but breaks some libtool versions.

2005-10-30  Jan Nieuwenhuizen  <janneke@gnu.org>

	* Apbuild/GCC.pm (new): New member variable: searchPaths.  Bugfix:
	  add LIBRARY_PATH to initialization.
	  (addSearchPaths): New function.
	  (getSearchPaths): Use searchPaths.

	* Apbuild/Utils.pm (searchLib): Bugfix: correct order of search
	  dirs.

	* apgcc (removeLibraries): Maintain searchPath for full .so name.

October 16 2005  <hongli@plan99.net>
	* apgcc: Correctly double compile C++ binaries during linking.

September 28 2005  Hongli Lai  <hongli@plan99.net>
	* Support $APBUILD_NO_RPATH: don't add rpath entries.
	  Feature request by Andreas.

September 3 2005  Hongli Lai  <hongli@plan99.net>
	* relaytool: support W, V and G symbols (experimental C++ support)

August 5 2005  Hongli Lai  <hongli@plan99.net>
	* apgcc and GCC.pm: fixed an argument reordering bug.
	* Makefile: add make-icons to distrbution.

2005-08-02  Mike Hearn  <mike@plan99.net>
	* relaytool: Remove -include flags, if any. This makes relaytool
	  precompiled-header safe.
	
2005-07-31  Mike Hearn  <mike@plan99.net>
	* relaytool.m4, relaytool: Optimization: use -ffunction-sections
	  and --gc-sections to eliminate unused jump slots
	* relaytool: Don't break when CFLAGS is set
	* relaytool: Optimization: only generate jump slots for exported
	  symbols from the library.
	
July 30 2005  Hongli Lai  <hongli@plan99.net>
	* Apbuild/GCC.pm: Commit Joseph's patch: fix $gcc->isLibrary()

2005-07-20  Mike Hearn  <mike@plan99.net>
	* Makefile (dist): Ship relaytool.m4, make extra scripts +x
	* relaytool.m4: Big improvements to the way you integrate with
	  C/C++ build systems.

July 9 2005  Hongli Lai  <hongli@plan99.net>
	* apgcc, Apbuild/GCC.pm (rearrangeForAsNeeded):
	  Fix rearrangement of objects: don't recognize parameters
	  (-Wl,foo.so) as objects.

Thu Jun 16 22:43:55 2005  Mike Hearn  <mike@navi.cx>
	* make-icons: Add a script to generate icon theme dropins from an SVG
	  file, a convenient utility for developers

May 31 2005  Hongli Lai  <hongli@navi.cx>
	* apgcc: Automatically compile C++ source files with two different
	  ABIs. By default, C++ files are compiled with ABI 1. Another
	  file with ABI 2 is stored as output.o.GCCABI2

May 16th 2005  Vincent Béron <vberon@mecano.gme.usherb.ca>
	* relaytool: Keep only one copy of a given symbol per lib.
	* relaytool: libdl won't ever be supported by relaytool, so skip it.
	* relaytool: Add a --version option, reorganize a bit the rest of --help.
	* relaytool: Allow generating a stub file for every library passed in args.
	* relaytool: Skip generating a stub for libraries for which no functions 
	  are called or no variables used.
	* relaytool: Use proper quoting.
	* relaytool: Support old nm versions

May 15th 2005  Vincent Béron <vberon@mecano.gme.usherb.ca>
	* relaytool: Allow relaytool to understand more than one --relay 
	  parameter.
	* relaytool: Enable (via --minimal-list) relaytool to only 
	  generate the minimum list of symbols by looking which ones are 
	  undefined in .o objects.
	* relaytool: Use CFLAGS (if available) while compiling the stub file.
	* relaytool: Use a shell function to do the same thing as 
	  readlink -f as the latter isn't always understood by readlink.
	* relaytool: Fix a typo in PPC C code.

May 14th 2005  Vincent Béron <vberon@mecano.gme.usherb.ca>
	* relaytool: Don't accidentally exclude all symbols with _init
	  or _fini in their names.

April 16 2005  Hongli Lai  <hongli@navi.cx>
	* Add new tool 'scandeps' which makes it easier for you to find
	  your software's library dependancies.
	* Improve documentation.

April 15 2005  Hongli Lai  <hongli@navi.cx>
	* apgcc: add support for $APBUILD_INCLUDE, which allows you
	  to prepend any folder to the header search path.
	* Improve documentation.

Fri Apr 15 22:47:06 2005  Mike Hearn  <mike@navi.cx>
	* apsymbols.h: Update to glibc 2.3.5
	* buildlist: Don't spew so many errors

April 10 2005  Hongli Lai  <hongli@navi.cx>
	* What? We have a ChangeLog? I didn't know that!
	  In the last 2 weeks I worked on these:
	- Support for GCC 3.4+'s --as-needed, for smarter automatic bogus
	  dependancy stripping.
	- Improved our own dependancy stripper.
	- Big code cleanups.

Tue Apr  5 02:14:49 2005  Mike Hearn  <mike@navi.cx>
	* relaytool.m4: Add an autoconf check for relaytool

Mon Feb 14 00:37:46 2005  Mike Hearn  <mike@navi.cx>
	* relaytool: Add --no-replace option, fix misc bugs revealed by
	  actually using relaytool in a real app

Fri Feb 11 23:49:24 2005  Mike Hearn  <mike@navi.cx>
	* relaytool: don't request PROT_EXEC permissions, they aren't
	  needed

2004-06-06  Mike Hearn  <mike@navi.cx>
	* relaytool: make relaytool jump thunks NX safe by using mmap
	  rather than malloc.
	
	* relaytool: Fix ELF scoping of dummy symbols for variable
	  imports, so the definitions in the imported lib don't get
	  resolved to the dummies (not all libs are compiled -Bsymbolic)
	
	* relaytool: support partial maps
	
